
CoCoA-5 - Bug #117

Added 3 times defn of isblank fn

03 Apr 2012 14:44 - John Abbott

Status: Closed Start date: 03 Apr 2012

Priority: High Due date:  

Assignee: John Abbott % Done: 100%

Category: Portability Estimated time: 2.00 hours

Target version: CoCoA-5.1.3/4 Jan 2016 Spent time: 1.35 hour

Description

To enable compilation on MSVC, I had to add defn of isblank.

Currently there are 3 separate (but identical) defns in the following files:

AST.C

C5.C

Lexer.C

It would be better to have a single defn somewhere; or perhaps import it from BOOST (if they offer one).

History

#1 - 03 Apr 2012 14:58 - John Abbott

As far as I can tell BOOST does not offer such a simple fn.

#2 - 31 May 2012 18:11 - Anna Maria Bigatti

- Category set to Portability

#3 - 01 Jun 2012 23:44 - John Abbott

Maybe put IsBlank into a file called C5utils?

What do you think?  Perhaps a few other fns could be moved there too?

#4 - 02 Jun 2012 22:54 - Anna Maria Bigatti

John Abbott wrote:

Maybe put IsBlank into a file called C5utils?

What do you think?  Perhaps a few other fns could be moved there too?

 

I think it could be a good idea.

It could be a good place for functions which might be sooner or later imported from BOOST or C++11

#5 - 02 Apr 2014 17:34 - Anna Maria Bigatti

- Target version set to CoCoA-5.1.0 Easter14

#6 - 09 Apr 2014 17:35 - John Abbott

- Target version changed from CoCoA-5.1.0 Easter14 to CoCoA-5.1.1 Seoul14
#7 - 28 Aug 2014 14:20 - John Abbott

- Target version changed from CoCoA-5.1.1 Seoul14 to CoCoA-5.1.2 summer 2015

- Estimated time changed from 1.00 h to 2.00 h

#8 - 30 Jul 2015 17:25 - John Abbott

There is a C++ function called isspace which returns true for space, TAB, and 4 others: '\n' (newline), '\v' (vertical tab), '\f' (form feed), '\r' (carriage

return).

The fn comes from C, and appears to be in header <cctype>.

Can we replace IsBlank by this standard function?  Our defn of IsBlank simply checks for space or TAB.

#9 - 30 Jul 2015 17:33 - John Abbott

- Priority changed from Normal to High

- Target version changed from CoCoA-5.1.2 summer 2015 to CoCoA-5.1.3/4 Jan 2016

Postponing to next version.  Increased priority (so I might actually do something).

#10 - 08 Oct 2015 14:41 - John Abbott

- Status changed from New to In Progress

- % Done changed from 0 to 20

I have put the fn into a new file C5Utils.H; so far there is no C5Utils.C file.

Everything compiles, and tests pass.

Is it worth creating a new file to avoid repeated defn of such a short and simple fn?

Note: I changed the name of the fn to IsBlank

#11 - 08 Oct 2015 14:49 - John Abbott

- Assignee set to John Abbott

I recall that GMP often has a file containing just a single function, and indeed for speed of recompilation it is better to have many small files.

It is certainly not a good idea to have several functions with the same name and same definition.

So overall I think it is worth creating an extra file.

#12 - 09 Oct 2015 20:11 - John Abbott

- Status changed from In Progress to Feedback

- % Done changed from 20 to 90

I've checked in: 1 new file, 3 modified files.  All should be OK.

#13 - 17 Feb 2016 13:25 - John Abbott
- Status changed from Feedback to Closed

- % Done changed from 90 to 100

Apparently this has been working fine for 4 months or more, so closing.
